"use client"
"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  Mutation: () => Mutation,
  PrefetchInfiniteQuery: () => PrefetchInfiniteQuery,
  PrefetchQuery: () => PrefetchQuery,
  QueryClientConsumer: () => QueryClientConsumer,
  SuspenseInfiniteQuery: () => SuspenseInfiniteQuery,
  SuspenseQueries: () => SuspenseQueries,
  SuspenseQuery: () => SuspenseQuery,
  infiniteQueryOptions: () => infiniteQueryOptions,
  mutationOptions: () => mutationOptions,
  queryOptions: () => queryOptions,
  usePrefetchInfiniteQuery: () => usePrefetchInfiniteQuery,
  usePrefetchQuery: () => usePrefetchQuery,
  useSuspenseInfiniteQuery: () => useSuspenseInfiniteQuery,
  useSuspenseQueries: () => useSuspenseQueries,
  useSuspenseQuery: () => useSuspenseQuery
});
module.exports = __toCommonJS(index_exports);

// src/queryOptions.ts
function queryOptions(options) {
  return options;
}

// src/infiniteQueryOptions.ts
function infiniteQueryOptions(options) {
  return options;
}

// src/useSuspenseQuery.ts
var import_react_query = require("@tanstack/react-query");
function useSuspenseQuery(options) {
  return (0, import_react_query.useQuery)(__spreadProps(__spreadValues({}, options), {
    enabled: true,
    useErrorBoundary: true,
    suspense: true,
    networkMode: "always"
  }));
}

// src/useSuspenseQueries.ts
var import_react_query2 = require("@tanstack/react-query");
function useSuspenseQueries({
  queries,
  context
}) {
  return (0, import_react_query2.useQueries)({
    queries: queries.map((query) => __spreadProps(__spreadValues({}, query), {
      suspense: true
    })),
    context
  });
}

// src/useSuspenseInfiniteQuery.ts
var import_react_query3 = require("@tanstack/react-query");
function useSuspenseInfiniteQuery(options) {
  return (0, import_react_query3.useInfiniteQuery)(__spreadProps(__spreadValues({}, options), {
    enabled: true,
    suspense: true,
    useErrorBoundary: true,
    networkMode: "always"
  }));
}

// src/usePrefetchQuery.ts
var import_react_query4 = require("@tanstack/react-query");
function usePrefetchQuery(options) {
  const queryClient = (0, import_react_query4.useQueryClient)();
  if (typeof options.queryKey !== "undefined" && !queryClient.getQueryState(options.queryKey)) {
    queryClient.prefetchQuery(options);
  }
}

// src/usePrefetchInfiniteQuery.ts
var import_react_query5 = require("@tanstack/react-query");
function usePrefetchInfiniteQuery(options) {
  const queryClient = (0, import_react_query5.useQueryClient)();
  if (typeof options.queryKey !== "undefined" && !queryClient.getQueryState(options.queryKey)) {
    queryClient.prefetchInfiniteQuery(options);
  }
}

// src/SuspenseQuery.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var SuspenseQuery = (_a) => {
  var _b = _a, {
    children
  } = _b, options = __objRest(_b, [
    "children"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: children(useSuspenseQuery(options)) });
};

// src/SuspenseQueries.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
function SuspenseQueries({
  children,
  queries
}) {
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: children(useSuspenseQueries({ queries })) });
}

// src/SuspenseInfiniteQuery.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
var SuspenseInfiniteQuery = (_a) => {
  var _b = _a, {
    children
  } = _b, options = __objRest(_b, [
    "children"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_jsx_runtime3.Fragment, { children: children(useSuspenseInfiniteQuery(options)) });
};

// src/PrefetchQuery.tsx
var import_jsx_runtime4 = require("react/jsx-runtime");
function PrefetchQuery(options) {
  usePrefetchQuery(options);
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_jsx_runtime4.Fragment, {});
}

// src/PrefetchInfiniteQuery.tsx
var import_jsx_runtime5 = require("react/jsx-runtime");
function PrefetchInfiniteQuery(options) {
  usePrefetchInfiniteQuery(options);
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_jsx_runtime5.Fragment, {});
}

// src/Mutation.tsx
var import_react_query6 = require("@tanstack/react-query");
var import_jsx_runtime6 = require("react/jsx-runtime");
function Mutation(_a) {
  var _b = _a, {
    children
  } = _b, options = __objRest(_b, [
    "children"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_jsx_runtime6.Fragment, { children: children((0, import_react_query6.useMutation)(options)) });
}

// src/mutationOptions.tsx
function mutationOptions(options) {
  return options;
}

// src/QueryClientConsumer.tsx
var import_react_query7 = require("@tanstack/react-query");
var import_jsx_runtime7 = require("react/jsx-runtime");
function QueryClientConsumer({
  children,
  context
}) {
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_jsx_runtime7.Fragment, { children: children((0, import_react_query7.useQueryClient)({ context })) });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Mutation,
  PrefetchInfiniteQuery,
  PrefetchQuery,
  QueryClientConsumer,
  SuspenseInfiniteQuery,
  SuspenseQueries,
  SuspenseQuery,
  infiniteQueryOptions,
  mutationOptions,
  queryOptions,
  usePrefetchInfiniteQuery,
  usePrefetchQuery,
  useSuspenseInfiniteQuery,
  useSuspenseQueries,
  useSuspenseQuery
});
//# sourceMappingURL=index.cjs.map