import { InfiniteData, QueryKey, UseInfiniteQueryOptions } from '@tanstack/react-query';
import { O as OmitKeyof } from './OmitKeyof-CFsZLI4k.js';
import { R as RequiredKeyof } from './RequiredKeyof-CHKtWddC.js';

type SelectedInfiniteOptions<TQueryFnData, TError = unknown, TData = InfiniteData<TQueryFnData>, TQueryKey extends QueryKey = QueryKey> = RequiredKeyof<OmitKeyof<UseInfiniteQueryOptions<TQueryFnData, TError, TData, TQueryFnData, TQueryKey>, 'queryKeyHashFn' | '_defaulted' | 'behavior' | 'structuralSharing' | 'isDataEqual' | 'onSuccess' | 'onError' | 'onSettled' | 'enabled' | 'refetchInterval' | 'initialData' | 'networkMode'>, 'queryKey' | 'queryFn'> & {
    select: (data: InfiniteData<TQueryFnData>) => InfiniteData<TData>;
};
type UnSelectedInfiniteOptions<TQueryFnData, TError = unknown, TData = InfiniteData<TQueryFnData>, TQueryKey extends QueryKey = QueryKey> = RequiredKeyof<OmitKeyof<UseInfiniteQueryOptions<TQueryFnData, TError, TData, TQueryFnData, TQueryKey>, 'queryKeyHashFn' | '_defaulted' | 'behavior' | 'structuralSharing' | 'isDataEqual' | 'onSuccess' | 'onError' | 'onSettled' | 'enabled' | 'refetchInterval' | 'initialData' | 'networkMode'>, 'queryKey' | 'queryFn'> & {
    select?: undefined;
};
declare function infiniteQueryOptions<TQueryFnData, TError = unknown, TData = InfiniteData<TQueryFnData>, TQueryKey extends QueryKey = QueryKey>(options: SelectedInfiniteOptions<TQueryFnData, TError, TData, TQueryKey>): SelectedInfiniteOptions<TQueryFnData, TError, TData, TQueryKey>;
declare function infiniteQueryOptions<TQueryFnData, TError = unknown, TData = InfiniteData<TQueryFnData>, TQueryKey extends QueryKey = QueryKey>(options: UnSelectedInfiniteOptions<TQueryFnData, TError, TData, TQueryKey>): UnSelectedInfiniteOptions<TQueryFnData, TError, TData, TQueryKey>;

export { type SelectedInfiniteOptions, type UnSelectedInfiniteOptions, infiniteQueryOptions };
