import { QueryKey, UseQueryOptions } from '@tanstack/react-query';
import { O as OmitKeyof } from './OmitKeyof-CFsZLI4k.js';
import { R as RequiredKeyof } from './RequiredKeyof-CHKtWddC.js';

type SelectedQueryOptions<TQueryFnData = unknown, TError = unknown, TData = TQueryFnData, TQueryKey extends QueryKey = QueryKey> = RequiredKeyof<OmitKeyof<UseQueryOptions<TQueryFnData, TError, TData, TQueryKey>, 'getNextPageParam' | 'getPreviousPageParam' | 'queryKeyHashFn' | '_defaulted' | 'behavior' | 'structuralSharing' | 'isDataEqual' | 'onSuccess' | 'onError' | 'onSettled' | 'enabled' | 'refetchInterval' | 'initialData' | 'networkMode'>, 'queryKey' | 'queryFn'> & {
    select: (data: TQueryFnData) => TData;
};
type UnSelectedQueryOptions<TQueryFnData = unknown, TError = unknown, TData = TQueryFnData, TQueryKey extends QueryKey = QueryKey> = RequiredKeyof<OmitKeyof<UseQueryOptions<TQueryFnData, TError, TData, TQueryKey>, 'getNextPageParam' | 'getPreviousPageParam' | 'queryKeyHashFn' | '_defaulted' | 'behavior' | 'structuralSharing' | 'isDataEqual' | 'onSuccess' | 'onError' | 'onSettled' | 'enabled' | 'refetchInterval' | 'initialData' | 'networkMode'>, 'queryKey' | 'queryFn'> & {
    select?: undefined;
};
/**
 * Creates a reusable query options object that can be used across different query hooks.
 * Provides better type inference and easier query key management.
 *
 * @see {@link https://suspensive.org/docs/react-query/queryOptions Suspensive Docs}
 */
declare function queryOptions<TQueryFnData = unknown, TError = unknown, TData = TQueryFnData, TQueryKey extends QueryKey = QueryKey>(options: SelectedQueryOptions<TQueryFnData, TError, TData, TQueryKey>): SelectedQueryOptions<TQueryFnData, TError, TData, TQueryKey>;
declare function queryOptions<TQueryFnData = unknown, TError = unknown, TData = TQueryFnData, TQueryKey extends QueryKey = QueryKey>(options: UnSelectedQueryOptions<TQueryFnData, TError, TData, TQueryKey>): UnSelectedQueryOptions<TQueryFnData, TError, TData, TQueryKey>;

export { type SelectedQueryOptions, type UnSelectedQueryOptions, queryOptions };
