import { QueryKey, FetchInfiniteQueryOptions } from '@tanstack/react-query';

/**
 * The `usePrefetchInfiniteQuery` does not return anything, it should be used just to fire a prefetch during render, before a suspense boundary that wraps a component that uses `useSuspenseInfiniteQuery`.
 * @see {@link https://suspensive.org/docs/react-query/usePrefetchInfiniteQuery Suspensive Docs}
 */
declare function usePrefetchInfiniteQuery<TQueryFnData = unknown, TError = unknown, TData = TQueryFnData, TQueryKey extends QueryKey = QueryKey>(options: FetchInfiniteQueryOptions<TQueryFnData, TError, TData, TQueryKey>): void;

export { usePrefetchInfiniteQuery };
